config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, controllers: { sessions: 'sessions' }
  namespace :admin do
    root to: 'dashboard#index'

    resources :static_pages
    resources :reviews
    resources :users
    resources :portfolios
    resources :videos
    resources :articles
    resources :subcategories
    resources :categories
    resources :vendors
  end

  mount API::Base, at: '/'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/admin_user.rb
class AdminUser < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/models/api_key.rb
class ApiKey < ApplicationRecord
  attr_accessor :application
  before_create :generate_access_token
  before_create :set_expiration
  belongs_to :user

  def expired?
    DateTime.now >= self.expires_at
  end

  private
  def generate_access_token
    begin
      self.access_token = SecureRandom.hex
    end while self.class.exists?(access_token: access_token)
  end

  def set_expiration
    self.expires_at = DateTime.now+30
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord

  validates :title, presence: true, length: { maximum: 255 }
  validates :content, presence: true
  validates :image, presence: true

  mount_uploader :image, ArticleImageUploader

  default_scope -> { order(:id) }

end

app/models/category.rb
class Category < ApplicationRecord
  has_many :subcategories
  has_many :vendors

  validates :title, presence: true, length: { maximum: 255 }
  validates :image, presence: true

  mount_uploader :image, CategoryImageUploader
end

app/models/portfolio.rb
class Portfolio < ApplicationRecord
  belongs_to :vendor

  validates :vendor_id, presence: true
  validates :image, presence: true

  mount_uploader :image, PortfolioImageUploader
end

app/models/review.rb
class Review < ApplicationRecord
  belongs_to :user, required: false
  belongs_to :vendor, required: false

  validates :user_id, presence: true
  validates :vendor_id, presence: true
  validates :review, presence: true,
    numericality: { only_integer: true, less_than_or_equal_to: 5, greater_than_or_equal_to: 1 }

  after_save :update_vendor

  def update_vendor
    vendor = Vendor.select('avg(reviews.review) AS average_review, count(reviews.id) AS reviews_count')
            .joins('LEFT JOIN reviews ON vendors.id = reviews.vendor_id')
            .where("vendors.id = #{vendor_id}").first

    self.vendor.update!(average_review: vendor[:average_review], reviews_count: vendor[:reviews_count])
  end
end

app/models/static_page.rb
class StaticPage < ApplicationRecord
  validates :name, presence: true, length: { maximum: 100 }

end

app/models/subcategory.rb
class Subcategory < ApplicationRecord
  belongs_to :category, required: false
  has_many :vendors

  validates :title, presence: true, length: { maximum: 255 }
  validates :category_id, presence: true
end

app/models/user.rb
require 'bcrypt'

class User < ApplicationRecord
  has_secure_password

  validates :username,
    presence: true,
    length: { maximum: 100 },
    uniqueness: true

  validates :email,
    presence: true,
    length: { maximum: 255 },
    uniqueness: true
end

app/models/vendor.rb
class Vendor < ApplicationRecord
  belongs_to :category, required: false
  belongs_to :subcategory, required: false
  has_many :portfolios
  has_many :reviews

  validates :title, presence: true, length: { maximum: 100 }
  validates :contact_number, presence: true, length: { maximum: 30 }
  validates :address, presence: true, length: { maximum: 255 }
  validates :fb_page_url, presence: true, length: { maximum: 255 }
  validates :budget, presence: true, numericality: { only_integer: true }
  validates :category_id, presence: true
  validates :image, presence: true

  mount_uploader :image, VendorImageUploader

  scope :vendors_with_reviews, lambda { |category_id: nil, subcategory_id: nil, average_review: nil, budget_from: nil, budget_to: nil|
    query = all
    query = query.where(category_id: category_id) unless category_id.nil?
    query = query.where(subcategory_id: subcategory_id) unless subcategory_id.nil?
    unless average_review.nil?
     query = query.where("average_review >= #{average_review}")
    end
    query = query.where("budget >= #{budget_from}") unless budget_from.nil?
    query = query.where("budget <= #{budget_to}") unless budget_to.nil?

    query
  }
end

app/models/video.rb
class Video < ApplicationRecord

  validates :title, presence: true, length: { maximum: 255 }
  validates :content, presence: true
  validates :video, presence: true

  mount_uploader :video, VideoUploader
end

app/controllers/admin/articles_controller.rb
module Admin
  class ArticlesController < AdminController
    before_action :set_article, only: %i[show edit update destroy]

    # GET /articles
    # GET /articles.json
    def index
      @articles = Article.all
    end

    # GET /articles/1
    # GET /articles/1.json
    def show; end

    # GET /articles/new
    def new
      @article = Article.new
    end

    # GET /articles/1/edit
    def edit; end

    # POST /articles
    # POST /articles.json
    def create
      @article = Article.new(article_params)

      respond_to do |format|
        if @article.save
          format.html { redirect_to admin_article_url(@article), notice: 'Article was successfully created.' }
          format.json { render :show, status: :created, location: @article }
        else
          format.html { render :new }
          format.json { render json: @article.errors, status: :unprocessable_entity }
        end
      end
    end

    # PATCH/PUT /articles/1
    # PATCH/PUT /articles/1.json
    def update
      respond_to do |format|
        if @article.update(article_params)
          format.html { redirect_to admin_article_url(@article), notice: 'Article was successfully updated.' }
          format.json { render :show, status: :ok, location: @article }
        else
          format.html { render :edit }
          format.json { render json: @article.errors, status: :unprocessable_entity }
        end
      end
    end

    # DELETE /articles/1
    # DELETE /articles/1.json
    def destroy
      @article.destroy
      respond_to do |format|
        format.html { redirect_to articles_url, notice: 'Article was successfully destroyed.' }
        format.json { head :no_content }
      end
    end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_article
      @article = Article.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def article_params
      params.require(:article).permit(:title, :content, :image)
    end
  end
end

app/controllers/api/entities/articles.rb
module API
  module Entities
    class Articles < Grape::Entity
      expose :id
      expose :image_url
      expose :title
      expose :content
      expose :created_at
    end
  end
end

app/controllers/api/v1/articles.rb
module API
  module V1
    class Articles < Grape::API
      include API::V1::Defaults

      resource :articles do
        desc 'Return all articles'
        get '', root: :articles do
          present Article.all, with: API::Entities::Articles
        end
      end
    end
  end
end

app/helpers/application_helper.rb
require 'uri'

module ApplicationHelper
  def is_active(page_name)
    uri = URI(request.original_url)
    page_name == uri.path.split('/')[2]
  end
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/helpers/portfolios_helper.rb
module PortfoliosHelper
end

app/helpers/reviews_helper.rb
module ReviewsHelper
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/helpers/subcategories_helper.rb
module SubcategoriesHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/vendors_helper.rb
module VendorsHelper
end

app/helpers/videos_helper.rb
module VideosHelper
end

app/views/admin/articles/_form.html.slim
= form_for [:admin, @article] do |f|
  - if @article.errors.any?
    #error_explanation
      h2 = "#{pluralize(@article.errors.count, "error")} prohibited this article from being saved:"
      ul
        - @article.errors.full_messages.each do |message|
          li = message

  .field
    = f.label :title
    = f.text_field :title, class: "form-control"
  .field
    = f.label :content
    = f.text_area :content, class: "form-control"
  .field
    = f.label :image
    = f.file_field :image, class: "form-control"
  .actions
    = f.submit "Submit", :class => "btn btn-primary"

app/views/admin/articles/edit.html.slim
h1 Editing article

== render 'form'

=> link_to 'Show', admin_article_path(@article)
'|
=< link_to 'Back', admin_articles_path

app/views/admin/articles/index.html.slim
section.content-header
  h1 Manage Articles

section.content
  div.box
    div.box-header.with-border
      h3.box-title List

    div.box-body
      table.table.table-bordered.table-hover
        thead
          tr
            th Title
            th style="width:10em" Image
            th colspan="3"
        tbody
          - @articles.each do |article|
            tr
              td
                = article.title
              td
                = image_tag article.image
              td style="width:7em"
                = fa_icon "eye"
                = link_to "View", admin_article_path(article)
              td style="width:7em"
                = fa_icon "pencil"
                = link_to "Edit", edit_admin_article_path(article)
              td style="with:7em"
                = fa_icon "remove"
                = link_to "Delete", admin_article_path(article), method: :delete, data: { confirm: "This record will be deleted. Are you sure?" }
      br
      = link_to 'New Article', new_admin_article_path, { class: "btn btn-default" }

app/views/admin/articles/new.html.slim
h1 New article

== render 'form'

= link_to 'Back', admin_articles_path

app/views/admin/articles/show.html.slim
p#notice = notice

p
  strong Title:
  = @article.title
p
  strong Content:
  = @article.content
p
  strong Image:
  = @article.image

=> link_to 'Edit', edit_admin_article_path(@article)
'|
=< link_to 'Back', admin_articles_path